###############################################################################
#
# Copyright (C) 2005-2006 IDA Software Technologies
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###############################################################################

""" Rakun Entity object action provider
"""
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass


from Products.CMFCore.ActionProviderBase import ActionProviderBase
class ActionProvider(ActionProviderBase):
    """ Provide ActionTabs and management methods for ActionProviders
    """

    security = ClassSecurityInfo()    

    manage_options = ActionProviderBase.manage_options

    #
    #   ActionProvider interface
    #
    security.declarePublic('listFilteredActionsFor')
    def listFilteredActionsFor(self):
        """ List all actions available to the user.
        """    
        actions = []
        action_infos = self.listActionInfos(object=self)         
        for ai in action_infos:            
            title = self.get_i18n_message(ai['title'])
            actions.append({'id':ai['id'],
                            'title':title,
                            'action':ai['url'],
                            'category':ai['category']
                            })
        return actions
        
        
InitializeClass(ActionProvider)
