###############################################################################
#
# Copyright (C) 2005-2006 IDA Software Technologies
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###############################################################################

from AccessControl import ClassSecurityInfo
from OFS.SimpleItem import SimpleItem
from OFS.PropertyManager import PropertyManager
from Products.CMFCore.utils import UniqueObject 
from Globals import InitializeClass

from sql.Sql99 import sqlClasses
from Permissions import RakunAccessDatabase,ManagePortal
from Settings import DatabaseToolName, DatabaseToolMetaType

class DatabaseTool(UniqueObject, SimpleItem, PropertyManager):
    """
       Database Tool 
    """
    
    id = DatabaseToolName
    meta_type = DatabaseToolMetaType
    toolicon = 'zmi/dbtool.gif'
    security = ClassSecurityInfo()
    
    manage_options = (PropertyManager.manage_options
                     + SimpleItem.manage_options
                     )
    
    security.declareProtected(RakunAccessDatabase,"getSqlClasses")
    def getSqlClasses(self):
        return sqlClasses.keys()
    
    security.declareProtected(RakunAccessDatabase,"getDBObject")
    def getDBObject(self,sqlserverfamily,connectionid):
        connection = getattr(self,connectionid)
        dbobject = sqlClasses[sqlserverfamily]
        return dbobject(connection)
    
    
 
    
InitializeClass(DatabaseTool)    

    