###############################################################################
#
# Copyright (C) 2005-2006 IDA Software Technologies
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###############################################################################

"""Exception Classes for Rakun"""

# These classes are placed here so that they can be imported into TTW Python
# scripts. To do so, add the following line to your Py script:
# from Products.Rakun.Errors import ValidationError ....

from Products.PythonScripts.Utility import allow_class
from Products.Formulator.Errors import ValidationError
allow_class(ValidationError)

class RakunError(Exception):
    error_type = 'RakunError'
    def __init__(self, value):
        self.value = value
        
    def __str__(self):
        return str(self.value)
    
    
class RakunInsertError(RakunError):
    error_type = 'RakunInsertError'
    
allow_class(RakunInsertError)

class RakunUpdateError(RakunError):
    error_type = 'RakunUpdateError'
    
allow_class(RakunUpdateError)

class RakunDeleteError(RakunError):
    error_type = 'RakunDeleteError'
    
allow_class(RakunDeleteError)

class RakunValidationError(RakunError):
    error_type = 'RakunValidationError'
    
allow_class(RakunValidationError)

