###############################################################################
#
# Copyright (C) 2005-2006 IDA Software Technologies
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###############################################################################

from Products.Formulator.FieldRegistry import FieldRegistry, getPropertyFields
from Products.Formulator.Form import initializeForm
from Products.Formulator import HelperFields
from Products.Formulator.DummyField import fields as dummyfields
import Fields

def registerFields():
  fields = [(Fields.StringField,'www/StringField.gif'),
            (Fields.CheckBoxField,'www/CheckBoxField.gif'),
            (Fields.IntegerField,'www/IntegerField.gif'),
            (Fields.TextAreaField,'www/TextAreaField.gif'),
            (Fields.RawTextAreaField,'www/TextAreaField.gif'),
            (Fields.LinesField,'www/LinesField.gif'),
            (Fields.ListField,'www/ListField.gif'),
            (Fields.MultiListField,'www/MultiListField.gif'),
            (Fields.RadioField,'www/RadioField.gif'),
            (Fields.MultiCheckBoxField,'www/MultiCheckBoxField.gif'),
            (Fields.PasswordField,'www/PasswordField.gif'),
            (Fields.EmailField,'www/EmailField.gif'),
            (Fields.PatternField,'www/PatternField.gif'),
            (Fields.FloatField,'www/FloatField.gif'),
            (Fields.DateTimeField,'www/DateTimeField.gif'),
            (Fields.FileField,'www/FileField.gif'),
            (Fields.ImageField,'www/FileField.gif'),
            (Fields.LinkField,'www/LinkField.gif'),
            (Fields.LabelField,'www/LabelField.gif'),
            (Fields.RangedIntegerField,'www/RangedIntegerField.gif')]
  
  for field_class,field_icon in fields:
    FieldRegistry.registerField(field_class,field_icon)
    for propname,groupname in [('dbproperties','database'),
                               ('gridproperties','grid'),
                               ('formproperties','form')]:
      
      for field in getPropertyFields(getattr(field_class,propname)):
          field_class.form.add_field(field, groupname)
          tales_field = dummyfields.TALESField(field.id,
                                               title=field.get_value('title'),
                                               description="",
                                               default="",
                                               display_with=40,
                                               required=0)
          field_class.tales_form.add_field(tales_field, groupname)
          method_field = dummyfields.MethodField(field.id,
                                                 title=field.get_value("title"),
                                                 description="",
                                                 default="",
                                                 required=0)
          field_class.override_form.add_field(method_field, groupname)
    
    
def initializeFields(registrar):
  # make Dummy Fields into real fields
  FieldRegistry.initializeFields()

  # do initialization of Form class to make fields addable
  initializeForm(FieldRegistry)
    
  # register help for the product
  registrar.registerHelp()
  # register field help for all fields
  FieldRegistry.registerFieldHelp(registrar)