###############################################################################
#
# Copyright (C) 2005-2006 IDA Software Technologies
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###############################################################################

from Products.Formulator.Form import ZMIForm as BaseForm
from Globals import InitializeClass
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from Products.CMFFormController.ControllerPageTemplate import ControllerPageTemplate

default_text = """

<tal:body>

    <metal:block use-macro="here/form_template/macros/master">
    
        <metal:buttons fill-slot="subbuttons">
    
          <input type="submit" 
                   name="form.button.button1" 
                   value="OK" />
    
        </metal:buttons>
    
    </metal:block>
    
</tal:body>

"""

manage_addRakunForm = PageTemplateFile('zmi/addForm', globals(), __name__="manage_addRakunForm")

class Form(BaseForm,ControllerPageTemplate):
    meta_type = 'Rakun Form'
    
    default_text = default_text
    
    validators = []
    actions = []
    
    manage_main = BaseForm.manage_main
    manage_edit = ControllerPageTemplate.manage_main
    
    
    manage_options =(   {'label':'Fields', 'action':'manage_main',
                         'help':('Formulator', 'formContents.txt')},
                        {'label':'View', 'action':''},
                        {'label':'Test', 'action':'formTest',
                         'help':('Formulator', 'formTest.txt')},
                        {'label':'Order', 'action':'formOrder',
                         'help':('Formulator', 'formOrder.txt')},
                        {'label':'Settings', 'action':'formSettings',
                         'help':('Formulator', 'formSettings.txt')},
                        {'label':'XML', 'action':'formXML',
                         'help':('Formulator', 'formXML.txt')},
                        {'label':'Edit', 
                         'action':'manage_edit'},
                        {'label':'Validation',
                         'action':'manage_formValidatorsForm'},
                        {'label':'Actions',
                         'action':'manage_formActionsForm'},
                        )
    
    def __init__(self,id,title=""):
        ControllerPageTemplate.__init__(self,id,title)
        BaseForm.__init__(self,id,title)
        self.pt_edit(text=self.default_text, content_type="text/html")
    
    
InitializeClass(Form)


def manage_addForm(self,id,title='',REQUEST=None):
    " "
    self._setObject(id,Form(id,title))
    if REQUEST is not None:
        url = self.DestinationURL() + '/' + id + '/manage_main'
        REQUEST['RESPONSE'].redirect(url)
        
