###############################################################################
#
# Copyright (C) 2005-2006 IDA Software Technologies
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###############################################################################

# -*- coding: utf-8 -*-
from Interface import Interface


class ISql(Interface):     
        

    def render_sql_value(dbobject, value):
        """
        insert ve update işlemlerinde eşitliğin sağında
        koşul ifadelerinde operatorun sağında
        """
    
    def render_sql_insert_field():
        """
        insert işlemindeki alan adı
        """
    
    def render_sql_update_field():
        """
        update işlemindeki alan adı
        """
    
    def render_sql_field():
        """
        select ifadesindeki alan adı
        """

    def render_sql_function():
        """
        sql ifadesinde fonksiyon içine girecek ifade için
        """
        
    def get_sql_field_name():
        """
        select işleminden sonra veritabanından dönecek alan adı
        """
    
    def get_sql_field_alias():
        """
        select işleminden sonra zope'ta beklenen ad
        """
        
    def get_db_type():
        """
        veritabanı tipi
        """
        
    def render_sql_table():
        """
        select işlemi için tablo adı
        """
    
    def get_sql_join_condition():
        """
        relation nesnesi kullanıldığında join koşulu
        """
    
    def render_sql_condition():
        """
        koşul ifadelerinde operatorun solunda 
        """
    
    def render_sql_groupby():
        """
        select ifadesinde gruplama içinde kullanılacak alan adları
        """

    def render_sql_orderby():
        """
        sıralama için kullanılacak alanlar
        """
    


class IRpc(Interface):  
    

    def dump(marshaller, write):
        """
        XML-RPC Server nesneyi dışarıya gönderirken
        """
        
    def load(obj):
        """
        XML-RPC Server dışardan nesneyi aldığında
        """
    


class IXml(Interface):
    pass
