###############################################################################
#
# Copyright (C) 2005-2006 IDA Software Technologies
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###############################################################################

import sys, os
from AccessControl import allow_module, allow_class, allow_type,ModuleSecurityInfo
from Products.CMFCore.DirectoryView import registerDirectory 
from Products.CMFCore import utils
from Products.CMFCore import DirectoryView
from Products.CMFPlone.utils import ToolInit
from Module import Interface, manage_addInterface, manage_addInterfaceForm
from Module import MasterDetailForm, manage_addMasterDetailForm,\
     manage_addMasterDetailFormTemplate
from Entity import Entity, manage_addEntity, manage_addEntityForm

from FieldsRegistry import registerFields, initializeFields

from DatabaseTool import DatabaseTool 
from ApplicationTool import ApplicationTool, Application,\
     manage_addApplicationForm, manage_addApplication
from Settings import ApplicationToolName
import Patch
import sql, Permissions, Errors




from RequestManagement import RequestForm
allow_class(RequestForm)

ModuleSecurityInfo('Products.Rakun.RakunUtils').declarePublic('translate_wrapper')
allow_module('Products.Rakun.RakunUtils')



# Rakun Menu initialize
from MenuTool import MenuSeparator, manage_addMenuSeparator, manage_addMenuSeparatorForm
from MenuTool import MenuItem, manage_addMenuItem, manage_addMenuItemForm
from MenuTool import SubMenu, manage_addSubMenu, manage_addSubMenuForm
from MenuTool import MenuTool

# Rakun Relation Tool initialize
from RelationTool import RelationTool
from RelationTool import manage_addRelation1, manage_addRelation1Form, Relation1
from RelationTool import manage_addRelationN, manage_addRelationNForm, RelationN

rakun_globals = globals()
registerDirectory('skins',rakun_globals)
#registerModule('skins',rakun_globals)


this_module = sys.modules[ __name__ ]
tools = (DatabaseTool, ApplicationTool, MenuTool, RelationTool)
z_tool_bases = utils.initializeBasesPhase1(tools, this_module)

def initialize(registrar):

    registrar.registerClass(
        Application,
        constructors = (manage_addApplicationForm,manage_addApplication),
        icon = 'zmi/application.gif',
        visibility = None,
        )
    
    registrar.registerClass(
        Interface,
        constructors = (manage_addInterfaceForm, manage_addInterface),
        icon = os.path.join('zmi','interface.gif'),
        visibility = None,
        )
    
    registrar.registerClass(
        MasterDetailForm,
        constructors = (manage_addMasterDetailFormTemplate, 
                        manage_addMasterDetailForm),
        icon = os.path.join('zmi','interface.gif'),
        visibility = None,
        )
    # register fields
    registerFields()
    
    registrar.registerClass(
        Entity,
        constructors = (manage_addEntityForm, manage_addEntity),
        icon = os.path.join('zmi','entity.gif'),
        visibility = None,
        )    
    
    Entity.settings_form._realize_fields()    
    Entity.message_settings._realize_fields()
    # register fields
    initializeFields(registrar)
    
    # Menu Objects register
    registrar.registerClass(
        MenuSeparator,
        constructors = (manage_addMenuSeparatorForm,manage_addMenuSeparator),
        icon = 'zmi/menu_separator.gif',
        visibility = None
        )
    
    registrar.registerClass(
        MenuItem,
        constructors = (manage_addMenuItemForm,manage_addMenuItem),
        icon = 'zmi/menu_item.gif',
        visibility = None
        )
    
    registrar.registerClass(
        SubMenu,
        constructors = (manage_addSubMenuForm,manage_addSubMenu),
        icon = 'zmi/submenu.gif',
        visibility = None
        )
    # Relation Object register
    registrar.registerClass(
        Relation1,
        constructors = (manage_addRelation1Form,manage_addRelation1),
        icon = 'zmi/relation.gif',
        visibility = None
        )
    registrar.registerClass(
        RelationN,
        constructors = (manage_addRelationNForm,manage_addRelationN),
        icon = 'zmi/relation.gif',
        visibility = None
        )
    # Rakun Tools initialize
    utils.initializeBasesPhase2(z_tool_bases, registrar)
    ToolInit( 'Rakun Tools'
              , tools=tools
              , product_name='Rakun'  
              , icon= 'tool.gif'  
              ).initialize(registrar)
   
