###############################################################################
#
# Copyright (C) 2005-2006 IDA Software Technologies
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###############################################################################

from Products.Rakun.Fields import BaseField
from Functions import Relation,Function


def typeoff(obj):
    if isinstance(obj, basestring):
        return 'string'
    elif isinstance(obj, int):
        return 'integer'
    elif isinstance(obj, float):
        return 'float'
    #...
  
  
class FieldRenderer:
  
    
    def field_render(self,field,value):   
        """
        """
        if isinstance(field, BaseField) and isinstance(value, BaseField):
            field = '%s.%s'%(field.getEntityName(), field.getName())
            value = '%s.%s'%(value.getEntityName(), value.getName())
            return (field, value)
        
        elif isinstance(field, BaseField) and isinstance(value, Function):
            field = '%s.%s'%(field.getEntityName(), field.getName())
            value = value.render()
            return (field, value)
        
        
        elif isinstance(field,BaseField):
            renderer = getattr(self,'%s_render'%field['type'],self.dummy_render)
            field = '%s.%s'%(field.getEntityName(),field.getName())
            value = renderer(value)
            return (field, value)
        
        elif isinstance(field,Relation):
            if isinstance(value,BaseField):
                value = '%s.%s'%(value.getEntityName(), value.getName())
            else:
                renderer = getattr(self,'%s_render'%field.field['type'],self.dummy_render)
                value = renderer(value)
            field = field.generateFieldName()
            return (field, value)
        
        elif isinstance(field,basestring) and isinstance(value, BaseField):
            value = '%s.%s'%(value.getEntityName(), value.getName())
            return (field, value)
            
        else:
            value_type = typeoff(value)
            renderer = getattr(self, '%s_render'%value_type,self.dummy_render)
            value = renderer(value)
            return (field, value)
  
    def string_render(self,value):
        """  """
        return "'%s'" %value
    
    def text_render(self,value):
        """  """
        return self.string_render(value)
    
    def date_render(self,value):
        """  """
        return self.string_render(value)
  
    def boolean_render(self,value):
        if value in [1,'1',True,'True']:
            return 'true'
        else:
            return 'false'
  
    def integer_render(self,value):
        if value is not None:
            return '%s'%value
        else:
            return 'null'
    
    def float_render(self,value):
        return self.integer_render(value)
  
    def money_render(self,value):
        return "'%s'" %value
    
    def dummy_render(self,value):
        return '%s'%value
    
