###############################################################################
#
# Copyright (C) 2005-2006 IDA Software Technologies
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###############################################################################

# -*- coding:utf-8 -*-
from Interface import Interface
from Interface import Attribute


class ISql99(Interface):
    """ ANSI SQL-99 Interface """
  
    connection = Attribute('connection','Database connection object')
    
    def execQuery(query):
        """
        oluşturulan query veritabanı sunucusunda çalıştırıp sonucunu dönderir
        """    

    def select(tables, fields, condition=None, orderby=[], groupby=[], offset=0,
               limit=0):
        """
        sql select işlemi
        """
      
    def insert(tableid,fields):
        """
        fields : [(alan,değer),..]
        sql insert işlemi
        """
      
    def update(tableid,fields,condition=None):
        """
        fields: [(alan,değer),..]
        koşula uyan kayıtların güncellenmesi
        """
    
    def delete(table,condition):
        """
        koşula uyan kayıtların silinmesi
        """
    
    def rowCount(tables, condition=None, groupby=[]):
        """
        koşula uyan kayıt sayısı
        """
        
    def getAutoIncrementValue(tableid,fieldid):
        """"
        fieldid ile belirtilen alanın bir sonraki değeri
        """
        
    def getLastIncrementValue(tableid,fieldid):
        """
        fieldid ile belirtilen alanın en son değeri
        """
        
    def escapeBlob(blob):
        """ 
        blob nesnesindeki bazı karakterleri veritabanına yollarken 
        kaçırılması lazım 
        """
        
    def unescapeBlob(blob):
        """
        dosyayı veritabanına eklerken yapılan değişikliklerin geri alınması
        """