###############################################################################
#
# Copyright (C) 2005-2006 IDA Software Technologies
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###############################################################################

from Sql99 import Sql99, registerSqlClass

escape_characters = {'\x00':'&#00;',
                     '\x22':'&#22;',
                     '\x27':'&#27;',
                     '\x5C':'&#5C;'}

class Mysql(Sql99):
  
  __implements__ = (Sql99.__implements__,)
  
  like_keyword = 'like'  
  
  def escapeBlob(self, blob):
      for ch,escaped in escape_characters.items():
          blob = blob.replace(ch,escaped)
      return "'%s'" %blob
  
  def unescapeBlob(self, blob):
      if hasattr(blob,'tostring'):
          blob  = blob.tostring()
      for ch,escaped in escape_characters.items():
          blob = blob.replace(escaped,ch)
      return blob

registerSqlClass('mysql',Mysql)